Index: /trunk/src/VBox/ValidationKit/tests/autostart/tdAutostart1.py
===================================================================
--- /trunk/src/VBox/ValidationKit/tests/autostart/tdAutostart1.py	(revision 87215)
+++ /trunk/src/VBox/ValidationKit/tests/autostart/tdAutostart1.py	(revision 87216)
@@ -27,8 +27,10 @@
 """
 __version__ = "$Id$"
+
 # Standard Python imports.
 import os;
 import sys;
 import re;
+
 # Only the main script needs to modify the path.
 try:    __file__
@@ -36,4 +38,5 @@
 g_ksValidationKitDir = os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__))));
 sys.path.append(g_ksValidationKitDir);
+
 # Validation Kit imports.
 from testdriver import reporter;
@@ -43,17 +46,23 @@
 from testdriver import vboxtestvms;
 from testdriver import vboxwrappers;
+
 class VBoxManageStdOutWrapper(object):
     """ Parser for VBoxManage list runningvms """
+
     def __init__(self):
         self.sVmRunning = '';
+
     def __del__(self):
         self.close();
+
     def close(self):
         """file.close"""
         return;
+
     def read(self, cb):
         """file.read"""
         _ = cb;
         return "";
+
     def write(self, sText):
         """VBoxManage stdout write"""
@@ -77,4 +86,5 @@
             reporter.log('Logging: ' + self.sVmRunning);
         return None;
+
 class tdAutostartOs(vboxtestvms.BaseTestVm):
     """
@@ -97,7 +107,9 @@
         self.asVirtModesSup = ['hwvirt-np',];
         self.asParavirtModesSup = ['default',];
+
     @property
     def asTestBuildDirs(self):
         return self._asTestBuildDirs;
+
     @asTestBuildDirs.setter
     def asTestBuildDirs(self, value):
@@ -106,4 +118,5 @@
         if not self.sTestBuild:
             raise base.GenError("VirtualBox install package not found");
+
     def _findFile(self, sRegExp, asTestBuildDirs):
         """
@@ -128,4 +141,5 @@
         reporter.error('Failed to find a file matching "%s" in %s.' % (sRegExp, ','.join(asTestBuildDirs)));
         return None;
+
     def _createAutostartCfg(self, sDefaultPolicy = 'allow', asUserAllow = (), asUserDeny = ()):
         """
@@ -138,4 +152,5 @@
             sVBoxCfg = sVBoxCfg + sUserDeny + ' = {\n allow = false\n }\n';
         return sVBoxCfg;
+
     def _waitAdditionsIsRunning(self, oGuest, fWaitTrayControl):
         """
@@ -160,4 +175,5 @@
             cAttempt += 1;
         return fRc;
+
     def createSession(self, oSession, sName, sUser, sPassword, cMsTimeout = 10 * 1000, fIsError = True):
         """
@@ -195,4 +211,5 @@
             return (False, None);
         return (True, oGuestSession);
+
     def closeSession(self, oGuestSession, fIsError = True):
         """
@@ -213,4 +230,5 @@
                 return False;
         return True;
+
     def guestProcessExecute(self, oGuestSession, sTestName, cMsTimeout, sExecName, asArgs = (),
                             fGetStdOut = True, fIsError = True):
@@ -342,4 +360,5 @@
         reporter.log2('Process (PID %d) has exit code: %d; status: %d ' % (iPid, iExitCode, uExitStatus));
         return (fRc, uExitStatus, iExitCode, aBuf);
+
     def uploadString(self, oGuestSession, sSrcString, sDst):
         """
@@ -362,4 +381,5 @@
             fRc = reporter.errorXcpt('Upload string failed. Could not close the file %s' % sDst);
         return fRc;
+
     def uploadFile(self, oGuestSession, sSrc, sDst):
         """
@@ -386,4 +406,5 @@
                 fRc = reporter.error('No progress object returned');
         return fRc;
+
     def downloadFile(self, oGuestSession, sSrc, sDst, fIgnoreErrors = False):
         """
@@ -417,4 +438,5 @@
                 fRc = False;
         return fRc;
+
     def downloadFiles(self, oGuestSession, asFiles, fIgnoreErrors = False):
         """
@@ -445,4 +467,5 @@
                 reporter.log('warning: file "%s" was not downloaded, ignoring.' % (sGstFile,));
         return True;
+
     def _checkVmIsReady(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Start a guest process',
@@ -451,4 +474,5 @@
                                                   False, False);
         return fRc;
+
     def waitVmIsReady(self, oSession, fWaitTrayControl):
         """
@@ -477,4 +501,5 @@
             cAttempt += 1;
         return (fRc, oGuestSession);
+
     def _rebootVM(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Reboot the VM',
@@ -485,4 +510,5 @@
             reporter.error('Calling the reboot utility failed');
         return fRc;
+
     def rebootVMAndCheckReady(self, oSession, oGuestSession):
         """
@@ -499,4 +525,5 @@
         reporter.testDone();
         return (fRc, oGuestSession);
+
     def _powerDownVM(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Power down the VM',
@@ -507,4 +534,5 @@
             reporter.error('Calling the poweroff utility failed');
         return fRc;
+
     def powerDownVM(self, oGuestSession):
         """
@@ -522,4 +550,5 @@
         reporter.testDone();
         return fRc;
+
     def installAdditions(self, oSession, oGuestSession, oVM):
         """
@@ -531,4 +560,5 @@
         reporter.error('Not implemented');
         return False;
+
     def installVirtualBox(self, oGuestSession):
         """
@@ -538,4 +568,5 @@
         reporter.error('Not implemented');
         return False;
+
     def configureAutostart(self, oGuestSession, sDefaultPolicy = 'allow', asUserAllow = (), asUserDeny = ()):
         """
@@ -548,4 +579,5 @@
         reporter.error('Not implemented');
         return False;
+
     def createUser(self, oGuestSession, sUser):
         """
@@ -556,4 +588,5 @@
         reporter.error('Not implemented');
         return False;
+
     def checkForRunningVM(self, oSession, oGuestSession, sUser, sVmName):
         """
@@ -568,4 +601,5 @@
         reporter.error('Not implemented');
         return False;
+
     def getResourceSet(self):
         asRet = [];
@@ -573,4 +607,5 @@
             asRet.append(self.sHdd);
         return asRet;
+
     def _createVmDoIt(self, oTestDrv, eNic0AttachType, sDvdImage):
         """
@@ -585,4 +620,5 @@
                                      sHddControllerType = "SATA Controller", fPae = self.fPae, \
                                      cCpus = self.cCpus, sDvdImage = self.sGuestAdditionsIso);
+
     def _createVmPost(self, oTestDrv, oVM, eNic0AttachType, sDvdImage):
         _ = eNic0AttachType;
@@ -606,4 +642,5 @@
             fRc = False;
         return oVM if fRc else None;
+
     def getReconfiguredVm(self, oTestDrv, cCpus, sVirtMode, sParavirtMode = None):
         #
@@ -617,4 +654,5 @@
             return (False, None);
         return (True, oVM);
+
 class tdAutostartOsLinux(tdAutostartOs):
     """
@@ -628,4 +666,5 @@
         self.sVBoxInstaller = '^VirtualBox-.*\\.run$';
         return;
+
     def installAdditions(self, oSession, oGuestSession, oVM):
         """
@@ -703,4 +742,5 @@
         reporter.testDone();
         return (fRc, oGuestSession);
+
     def installVirtualBox(self, oGuestSession):
         """
@@ -734,4 +774,5 @@
         reporter.testDone();
         return fRc;
+
     def configureAutostart(self, oGuestSession, sDefaultPolicy = 'allow', asUserAllow = (), asUserDeny = ()):
         """
@@ -792,4 +833,5 @@
         reporter.testDone();
         return fRc;
+
     def createUser(self, oGuestSession, sUser):
         """
@@ -805,4 +847,5 @@
         reporter.testDone();
         return fRc;
+
     # pylint: enable=too-many-arguments
     def createTestVM(self, oSession, oGuestSession, sUser, sVmName):
@@ -839,4 +882,5 @@
         reporter.testDone();
         return fRc;
+
     def checkForRunningVM(self, oSession, oGuestSession, sUser, sVmName):
         """
@@ -861,4 +905,5 @@
         reporter.testDone();
         return fRc;
+
 class tdAutostartOsDarwin(tdAutostartOs):
     """
@@ -871,4 +916,5 @@
                                cCpus, fPae, sGuestAdditionsIso);
         raise base.GenError('Testing the autostart functionality for Darwin is not implemented');
+
 class tdAutostartOsSolaris(tdAutostartOs):
     """
@@ -881,4 +927,5 @@
                                cCpus, fPae, sGuestAdditionsIso);
         raise base.GenError('Testing the autostart functionality for Solaris is not implemented');
+
 class tdAutostartOsWin(tdAutostartOs):
     """
@@ -892,4 +939,5 @@
         self.sVBoxInstaller = '^VirtualBox-.*\\.(exe|msi)$';
         return;
+
     def _checkVmIsReady(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Start a guest process',
@@ -898,4 +946,5 @@
                                                   False, False);
         return fRc;
+
     def _rebootVM(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Reboot the VM',
@@ -907,4 +956,5 @@
             reporter.error('Calling the shutdown utility failed');
         return fRc;
+
     def _powerDownVM(self, oGuestSession):
         (fRc, _, _, _) = self.guestProcessExecute(oGuestSession, 'Power down the VM',
@@ -916,4 +966,5 @@
             reporter.error('Calling the shutdown utility failed');
         return fRc;
+
     def installAdditions(self, oSession, oGuestSession, oVM):
         """
@@ -1005,4 +1056,5 @@
         reporter.testDone();
         return (fRc and fGaRc, oGuestSession);
+
     def installVirtualBox(self, oGuestSession):
         """
@@ -1051,4 +1103,5 @@
         reporter.testDone();
         return fRc;
+
     def configureAutostart(self, oGuestSession, sDefaultPolicy = 'allow', asUserAllow = (), asUserDeny = ()):
         """
@@ -1074,4 +1127,5 @@
         reporter.testDone();
         return fRc;
+
     def createTestVM(self, oSession, oGuestSession, sUser, sVmName):
         """
@@ -1120,4 +1174,5 @@
         reporter.testDone();
         return fRc;
+
     def checkForRunningVM(self, oSession, oGuestSession, sUser, sVmName):
         """
@@ -1148,4 +1203,5 @@
         reporter.testDone();
         return fRc;
+
     def createUser(self, oGuestSession, sUser):
         """
@@ -1219,4 +1275,5 @@
         reporter.testDone();
         return fRc;
+
 class tdAutostart(vbox.TestDriver):                                      # pylint: disable=too-many-instance-attributes
     """
@@ -1250,7 +1307,9 @@
         # pylint: enable=line-too-long
         self.oTestVmSet = oSet;
+
     #
     # Overridden methods.
     #
+
     def showUsage(self):
         rc = vbox.TestDriver.showUsage(self);
@@ -1262,4 +1321,5 @@
         reporter.log('      option is not specified. At least, one directory should be pointed.');
         return rc;
+
     def parseOption(self, asArgs, iArg): # pylint: disable=too-many-branches,too-many-statements
         if asArgs[iArg] == '--test-build-dirs':
@@ -1272,4 +1332,5 @@
             return vbox.TestDriver.parseOption(self, asArgs, iArg);
         return iArg + 1;
+
     def completeOptions(self):
         # Remove skipped VMs from the test list.
@@ -1280,8 +1341,10 @@
             except: pass;
         return vbox.TestDriver.completeOptions(self);
+
     def actionConfig(self):
         if not self.importVBoxApi(): # So we can use the constant below.
             return False;
         return self.oTestVmSet.actionConfig(self);
+
     def actionExecute(self):
         """
@@ -1289,4 +1352,5 @@
         """
         return self.oTestVmSet.actionExecute(self, self.testAutostartOneVfg)
+
     #
     # Test execution helpers.
@@ -1352,4 +1416,5 @@
             fRc = False;
         return fRc;
+
 if __name__ == '__main__':
     sys.exit(tdAutostart().main(sys.argv));