Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageAppliance.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageAppliance.cpp	(revision 87241)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageAppliance.cpp	(revision 87278)
@@ -1113,4 +1113,5 @@
                         case VirtualSystemDescriptionType_CloudPublicSSHKey:
                         case VirtualSystemDescriptionType_BootingFirmware:
+                        case VirtualSystemDescriptionType_CloudInitScriptPath:
                             /** @todo  VirtualSystemDescriptionType_Miscellaneous? */
                             break;
@@ -1208,5 +1209,4 @@
     { "--opc10",                'c', RTGETOPT_REQ_NOTHING },
     { "--manifest",             'm', RTGETOPT_REQ_NOTHING },    // obsoleted by --options
-    { "--iso",                  'I', RTGETOPT_REQ_NOTHING },    // obsoleted by --options
     { "--vsys",                 's', RTGETOPT_REQ_UINT32 },
     { "--vmname",               'V', RTGETOPT_REQ_STRING },
@@ -1233,4 +1233,5 @@
     { "--cloudlaunchmode",      'M', RTGETOPT_REQ_STRING },
     { "--cloudprivateip",       'i', RTGETOPT_REQ_STRING },
+    { "--cloudinitscriptpath",  'I', RTGETOPT_REQ_STRING },
 };
 
@@ -1289,7 +1290,7 @@
                     break;
 
-                case 'I':   // --iso
-                    fExportISOImages = true;
-                    break;
+//              case 'I':   // --iso
+//                  fExportISOImages = true;
+//                  break;
 
                 case 'm':   // --manifest
@@ -1468,4 +1469,11 @@
                                            GetState.pDef->pszLong);
                     mapArgsMapsPerVsys[ulCurVsys]["cloudlaunchmode"] = ValueUnion.psz;
+                    break;
+
+                case 'I':   // --cloudinitscriptpath
+                    if (actionType != CLOUD)
+                        return errorSyntax(USAGE_EXPORTAPPLIANCE, "Option \"%s\" requires preceding --cloud argument.",
+                                           GetState.pDef->pszLong);
+                    mapArgsMapsPerVsys[ulCurVsys]["cloudinitscriptpath"] = ValueUnion.psz;
                     break;
 
@@ -1662,4 +1670,8 @@
                         pVSD->AddDescription(VirtualSystemDescriptionType_CloudLaunchInstance,
                                              Bstr(itD->second).raw(), NULL);
+                    else if (itD->first == "cloudinitscriptpath")
+                        pVSD->AddDescription(VirtualSystemDescriptionType_CloudInitScriptPath,
+                                             Bstr(itD->second).raw(), NULL);
+
                 }
             }
Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 87241)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageCloud.cpp	(revision 87278)
@@ -505,4 +505,5 @@
         { "--launch",         'l', RTGETOPT_REQ_STRING },
         { "--public-ssh-key", 'k', RTGETOPT_REQ_STRING },
+        { "--cloud-init-script-path", 'c', RTGETOPT_REQ_STRING },
         { "help",             1001, RTGETOPT_REQ_NOTHING },
         { "--help",           1002, RTGETOPT_REQ_NOTHING }
@@ -592,4 +593,8 @@
                                      Bstr(ValueUnion.psz).raw(), NULL);
                 break;
+            case 'c':
+                pVSD->AddDescription(VirtualSystemDescriptionType_CloudInitScriptPath,
+                                     Bstr(ValueUnion.psz).raw(), NULL);
+                break;
             case 1001:
             case 1002:
@@ -775,5 +780,5 @@
     };
 
-    const size_t vsdHReadableArraySize = 12;//the number of items in the vsdHReadableArray
+    const size_t vsdHReadableArraySize = 13;//the number of items in the vsdHReadableArray
     vsdHReadable vsdHReadableArray[vsdHReadableArraySize] = {
         {VirtualSystemDescriptionType_CloudDomain, "Availability domain = %ls\n", "Availability domain wasn't found\n"},
@@ -790,5 +795,6 @@
         {VirtualSystemDescriptionType_CPU, "CPUs = %ls\n", "Numbers of CPUs weren't found\n"},
         {VirtualSystemDescriptionType_CloudPublicIP, "Instance public IP = %ls\n", "Public IP wasn't found\n"},
-        {VirtualSystemDescriptionType_Miscellaneous, "%ls\n", "Free-form tags or metadata weren't found\n"}
+        {VirtualSystemDescriptionType_Miscellaneous, "%ls\n", "Free-form tags or metadata weren't found\n"},
+        {VirtualSystemDescriptionType_CloudInitScriptPath, "%ls\n", "Cloud-init script wasn't found\n"}
     };
 