Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 87293)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 87294)
@@ -184,6 +184,5 @@
     , m_pEnableUnattendedInstallCheckBox(0)
     , m_pStartHeadlessCheckBox(0)
-    , m_pNameAndFolderEditor(0)
-    , m_pSystemTypeEditor(0)
+    , m_pNameAndSystemEditor(0)
     , m_pUnattendedLabel(0)
     , m_pNameOSTypeLabel(0)
@@ -205,6 +204,6 @@
         if (strNewName.contains(gs_OSTypePattern[i].pattern))
         {
-            if (m_pSystemTypeEditor)
-                m_pSystemTypeEditor->setType(uiCommon().vmGuestOSType(gs_OSTypePattern[i].pcstId));
+            if (m_pNameAndSystemEditor)
+                m_pNameAndSystemEditor->setType(uiCommon().vmGuestOSType(gs_OSTypePattern[i].pcstId));
             break;
         }
@@ -215,6 +214,6 @@
     /* If the user manually edited the OS type, we didn't want our automatic OS type guessing anymore.
      * So simply disconnect the text-edit signal. */
-    if (m_pNameAndFolderEditor)
-        m_pNameAndFolderEditor->disconnect(SIGNAL(sigNameChanged(const QString &)), thisImp(), SLOT(sltNameChanged(const QString &)));
+    if (m_pNameAndSystemEditor)
+        m_pNameAndSystemEditor->disconnect(SIGNAL(sigNameChanged(const QString &)), thisImp(), SLOT(sltNameChanged(const QString &)));
 }
 
@@ -249,7 +248,7 @@
 void UIWizardNewVMPage1::composeMachineFilePath()
 {
-    if (!m_pNameAndFolderEditor)
+    if (!m_pNameAndSystemEditor)
         return;
-    if (m_pNameAndFolderEditor->name().isEmpty() || m_pNameAndFolderEditor->path().isEmpty())
+    if (m_pNameAndSystemEditor->name().isEmpty() || m_pNameAndSystemEditor->path().isEmpty())
         return;
     /* Get VBox: */
@@ -257,8 +256,8 @@
 
     /* Compose machine filename: */
-    m_strMachineFilePath = vbox.ComposeMachineFilename(m_pNameAndFolderEditor->name(),
+    m_strMachineFilePath = vbox.ComposeMachineFilename(m_pNameAndSystemEditor->name(),
                                                        m_strGroup,
                                                        QString(),
-                                                       m_pNameAndFolderEditor->path());
+                                                       m_pNameAndSystemEditor->path());
     /* Compose machine folder/basename: */
     const QFileInfo fileInfo(m_strMachineFilePath);
@@ -299,12 +298,12 @@
         m_pNameOSTypeLabel = new QIRichTextLabel;
         if (m_pNameOSTypeLabel)
-            pLayout->addWidget(m_pNameOSTypeLabel, iRow++, 0, 1, 4);
-    }
-
-    m_pNameAndFolderEditor = new UINameAndSystemEditor(0, true, true, false);
-    if (m_pNameAndFolderEditor)
-        pLayout->addWidget(m_pNameAndFolderEditor, iRow++, 0, 1, 4);
-
-    pLayout->addWidget(horizontalLine(), iRow++, 0, 1, 4);
+            pLayout->addWidget(m_pNameOSTypeLabel, iRow++, 0, 1, 6);
+    }
+
+    m_pNameAndSystemEditor = new UINameAndSystemEditor(0, true, true, true);
+    if (m_pNameAndSystemEditor)
+        pLayout->addWidget(m_pNameAndSystemEditor, iRow++, 0, 1, 6);
+
+    pLayout->addWidget(horizontalLine(), iRow++, 0, 1, 6);
 
     if (fCreateLabels)
@@ -312,9 +311,9 @@
         m_pUnattendedLabel = new QIRichTextLabel;
         if (m_pUnattendedLabel)
-            pLayout->addWidget(m_pUnattendedLabel, iRow++, 0, 1, 4);
+            pLayout->addWidget(m_pUnattendedLabel, iRow++, 0, 1, 6);
     }
 
     m_pEnableUnattendedInstallCheckBox = new QCheckBox;
-    pLayout->addWidget(m_pEnableUnattendedInstallCheckBox, iRow++, 0, 1, 2, Qt::AlignLeft);
+    pLayout->addWidget(m_pEnableUnattendedInstallCheckBox, iRow++, 0, 1, 1);
 
     m_pISOSelectorLabel = new QLabel;
@@ -324,5 +323,5 @@
         m_pISOSelectorLabel->setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Fixed);
         m_pISOSelectorLabel->setEnabled(false);
-        pLayout->addWidget(m_pISOSelectorLabel, iRow, 0, 1, 1, Qt::AlignRight);
+        pLayout->addWidget(m_pISOSelectorLabel, iRow, 1, 1, 1);
     }
     m_pISOFilePathSelector = new UIFilePathSelector;
@@ -332,7 +331,6 @@
         m_pISOFilePathSelector->setMode(UIFilePathSelector::Mode_File_Open);
         m_pISOFilePathSelector->setFileDialogFilters("*.iso *.ISO");
-        m_pISOFilePathSelector->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
         m_pISOFilePathSelector->setEnabled(false);
-        pLayout->addWidget(m_pISOFilePathSelector, iRow++, 1, 1, 3);
+        pLayout->addWidget(m_pISOFilePathSelector, iRow++, 2, 1, 4);
     }
 
@@ -341,12 +339,9 @@
     {
         m_pStartHeadlessCheckBox->setEnabled(false);
-        pLayout->addWidget(m_pStartHeadlessCheckBox, iRow++, 1, 1, 1);
+        pLayout->addWidget(m_pStartHeadlessCheckBox, iRow++, 1, 1, 5);
     }
 
     pLayout->addWidget(horizontalLine(), iRow++, 0, 1, 4);
 
-    m_pSystemTypeEditor = new UINameAndSystemEditor(0, false, false, true);
-    if (m_pSystemTypeEditor)
-        pLayout->addWidget(m_pSystemTypeEditor, iRow++, 0, 1, 4);
     return pContainer;
 }
@@ -354,5 +349,5 @@
 bool UIWizardNewVMPage1::createMachineFolder()
 {
-    if (!m_pNameAndFolderEditor)
+    if (!m_pNameAndSystemEditor)
         return false;
     /* Cleanup previosly created folder if any: */
@@ -441,7 +436,7 @@
 QString UIWizardNewVMPage1::guestOSFamiyId() const
 {
-    if (!m_pSystemTypeEditor)
+    if (!m_pNameAndSystemEditor)
         return QString();
-    return m_pSystemTypeEditor->familyId();
+    return m_pNameAndSystemEditor->familyId();
 }
 
@@ -482,6 +477,6 @@
     if (m_pISOFilePathSelector)
         m_pISOFilePathSelector->mark(!isISOFileSelectorComplete());
-    if (m_pNameAndFolderEditor)
-        m_pNameAndFolderEditor->markNameLineEdit(m_pNameAndFolderEditor->name().isEmpty());
+    if (m_pNameAndSystemEditor)
+        m_pNameAndSystemEditor->markNameLineEdit(m_pNameAndSystemEditor->name().isEmpty());
 }
 
@@ -528,6 +523,6 @@
     createConnections();
     /* Register fields: */
-    registerField("name*", m_pNameAndFolderEditor, "name", SIGNAL(sigNameChanged(const QString &)));
-    registerField("type", m_pSystemTypeEditor, "type", SIGNAL(sigOsTypeChanged()));
+    registerField("name*", m_pNameAndSystemEditor, "name", SIGNAL(sigNameChanged(const QString &)));
+    registerField("type", m_pNameAndSystemEditor, "type", SIGNAL(sigOsTypeChanged()));
     registerField("machineFilePath", this, "machineFilePath");
     registerField("machineFolder", this, "machineFolder");
@@ -544,7 +539,7 @@
     connect(m_pEnableUnattendedInstallCheckBox, &QCheckBox::clicked, this, &UIWizardNewVMPageBasic1::sltUnattendedCheckBoxToggle);
     connect(m_pISOFilePathSelector, &UIFilePathSelector::pathChanged, this, &UIWizardNewVMPageBasic1::sltISOPathChanged);
-    connect(m_pNameAndFolderEditor, &UINameAndSystemEditor::sigNameChanged, this, &UIWizardNewVMPageBasic1::sltNameChanged);
-    connect(m_pNameAndFolderEditor, &UINameAndSystemEditor::sigPathChanged, this, &UIWizardNewVMPageBasic1::sltPathChanged);
-    connect(m_pSystemTypeEditor, &UINameAndSystemEditor::sigOsTypeChanged, this, &UIWizardNewVMPageBasic1::sltOsTypeChanged);
+    connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigNameChanged, this, &UIWizardNewVMPageBasic1::sltNameChanged);
+    connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigPathChanged, this, &UIWizardNewVMPageBasic1::sltPathChanged);
+    connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigOsTypeChanged, this, &UIWizardNewVMPageBasic1::sltOsTypeChanged);
 }
 
@@ -560,5 +555,5 @@
 {
     markWidgets();
-    if (m_pNameAndFolderEditor->name().isEmpty())
+    if (m_pNameAndSystemEditor->name().isEmpty())
         return false;
     return isISOFileSelectorComplete();
@@ -620,5 +615,5 @@
                                              "to identify this machine."));
 
-    // if (   m_pNameAndFolderEditor
+    // if (   m_pNameAndSystemEditor
     //        && m_pSystemTypeEditor
     //        && m_pISOSelectorLabel)
@@ -626,5 +621,5 @@
     //     int iMinWidthHint = 0;
     //     iMinWidthHint = qMax(iMinWidthHint, m_pISOSelectorLabel->minimumSizeHint().width());
-    //     m_pNameAndFolderEditor->setMinimumLayoutIndent(iMinWidthHint);
+    //     m_pNameAndSystemEditor->setMinimumLayoutIndent(iMinWidthHint);
     //     m_pSystemTypeEditor->setMinimumLayoutIndent(iMinWidthHint);
     // }
@@ -635,6 +630,6 @@
     /* Translate page: */
     retranslateUi();
-    if (m_pNameAndFolderEditor)
-        m_pNameAndFolderEditor->setFocus();
+    if (m_pNameAndSystemEditor)
+        m_pNameAndSystemEditor->setFocus();
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h	(revision 87293)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h	(revision 87294)
@@ -95,6 +95,5 @@
        /** We have two UINameAndSystemEditor instance since name/vm path fields and OS type fields
         * are separated. */
-       UINameAndSystemEditor *m_pNameAndFolderEditor;
-       UINameAndSystemEditor *m_pSystemTypeEditor;
+       UINameAndSystemEditor *m_pNameAndSystemEditor;
        QIRichTextLabel *m_pUnattendedLabel;
        QIRichTextLabel *m_pNameOSTypeLabel;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 87293)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 87294)
@@ -69,6 +69,6 @@
     qRegisterMetaType<CMedium>();
     /* Register fields: */
-    registerField("name*", m_pNameAndFolderEditor, "name", SIGNAL(sigNameChanged(const QString &)));
-    registerField("type", m_pSystemTypeEditor, "type", SIGNAL(sigOsTypeChanged()));
+    registerField("name*", m_pNameAndSystemEditor, "name", SIGNAL(sigNameChanged(const QString &)));
+    registerField("type", m_pNameAndSystemEditor, "type", SIGNAL(sigOsTypeChanged()));
     registerField("machineFilePath", this, "machineFilePath");
     registerField("machineFolder", this, "machineFolder");
@@ -91,10 +91,13 @@
     registerField("VCPUCount", this, "VCPUCount");
 
+    const QPalette pal = palette();
+    QColor tabBackgroundColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(110);
+    QColor textColor = pal.color(QPalette::Active, QPalette::Text).lighter();
+    QColor disabledTextColor = pal.color(QPalette::Disabled, QPalette::Text).lighter();
+
     m_pToolBox->setStyleSheet(QString::fromUtf8("QToolBox::tab {\n"
-                                                "    background: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,\n"
-                                                "                                stop: 0 #E1E1E1, stop: 0.4 #DDDDDD,\n"
-                                                "                                stop: 0.5 #D8D8D8, stop: 1.0 #D3D3D3);\n"
+                                                "    background: %1; \n"
                                                 "    border-radius: 5px;\n"
-                                                "    color: black;\n"
+                                                "    color: %2;\n"
                                                 "}\n"
                                                 "\n"
@@ -108,6 +111,6 @@
                                                 "QToolBox::tab:disabled {\n"
                                                 "    font: italic;\n"
-                                                "    color: gray;\n"
-                                                "}"));
+                                                "    color: %3;\n"
+                                                "}").arg(tabBackgroundColor.name()).arg(textColor.name()).arg(disabledTextColor.name()));
 
     if (m_pEnableUnattendedInstallCheckBox)
@@ -137,5 +140,5 @@
 
     /* Fetch recommended RAM value: */
-    CGuestOSType type = m_pSystemTypeEditor->type();
+    CGuestOSType type = m_pNameAndSystemEditor->type();
     m_pBaseMemoryEditor->setValue(type.GetRecommendedRAM());
 
@@ -213,16 +216,13 @@
 {
     /* Connections for Name, OS Type, and unattended install stuff: */
-    if (m_pNameAndFolderEditor)
-    {
-        connect(m_pNameAndFolderEditor, &UINameAndSystemEditor::sigNameChanged,
+    if (m_pNameAndSystemEditor)
+    {
+        connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigNameChanged,
                 this, &UIWizardNewVMPageExpert::sltNameChanged);
-        connect(m_pNameAndFolderEditor, &UINameAndSystemEditor::sigPathChanged,
+        connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigPathChanged,
                 this, &UIWizardNewVMPageExpert::sltPathChanged);
-    }
-    if (m_pSystemTypeEditor)
-    {
-        connect(m_pSystemTypeEditor, &UINameAndSystemEditor::sigOsTypeChanged,
+        connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigOsTypeChanged,
                 this, &UIWizardNewVMPageExpert::sltOsTypeChanged);
-        connect(m_pSystemTypeEditor, &UINameAndSystemEditor::sigOSFamilyChanged,
+        connect(m_pNameAndSystemEditor, &UINameAndSystemEditor::sigOSFamilyChanged,
                 this, &UIWizardNewVMPageExpert::sltOSFamilyTypeChanged);
     }