Index: /trunk/include/VBox/vmm/cpum.h
===================================================================
--- /trunk/include/VBox/vmm/cpum.h	(revision 87344)
+++ /trunk/include/VBox/vmm/cpum.h	(revision 87345)
@@ -2629,8 +2629,6 @@
 VMMDECL(bool)           CPUMIsHostFPUStateSaved(PVMCPU pVCpu);
 VMMDECL(bool)           CPUMIsGuestDebugStateActive(PVMCPU pVCpu);
-VMMDECL(bool)           CPUMIsGuestDebugStateActivePending(PVMCPU pVCpu);
 VMMDECL(void)           CPUMDeactivateGuestDebugState(PVMCPU pVCpu);
 VMMDECL(bool)           CPUMIsHyperDebugStateActive(PVMCPU pVCpu);
-VMMDECL(bool)           CPUMIsHyperDebugStateActivePending(PVMCPU pVCpu);
 VMMDECL(uint32_t)       CPUMGetGuestCPL(PVMCPU pVCpu);
 VMMDECL(CPUMMODE)       CPUMGetGuestMode(PVMCPU pVCpu);
Index: /trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 87344)
+++ /trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 87345)
@@ -1613,8 +1613,9 @@
  * Checks if we activated the FPU/XMM state of the guest OS.
  *
- * This differs from CPUMIsGuestFPUStateLoaded() in that it refers to the next
- * time we'll be executing guest code, so it may return true for 64-on-32 when
- * we still haven't actually loaded the FPU status, just scheduled it to be
- * loaded the next time we go thru the world switcher (CPUM_SYNC_FPU_STATE).
+ * Obsolete: This differs from CPUMIsGuestFPUStateLoaded() in that it refers to
+ * the next time we'll be executing guest code, so it may return true for
+ * 64-on-32 when we still haven't actually loaded the FPU status, just scheduled
+ * it to be loaded the next time we go thru the world switcher
+ * (CPUM_SYNC_FPU_STATE).
  *
  * @returns true / false.
@@ -1623,5 +1624,5 @@
 VMMDECL(bool) CPUMIsGuestFPUStateActive(PVMCPU pVCpu)
 {
-    return RT_BOOL(pVCpu->cpum.s.fUseFlags & (CPUM_USED_FPU_GUEST | CPUM_SYNC_FPU_STATE));
+    return RT_BOOL(pVCpu->cpum.s.fUseFlags & CPUM_USED_FPU_GUEST);
 }
 
@@ -1664,38 +1665,12 @@
 
 /**
- * Checks if the guest debug state is to be made active during the world-switch
- * (currently only used for the 32->64 switcher case).
+ * Checks if the hyper debug state is active.
  *
  * @returns boolean
  * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
  */
-VMMDECL(bool) CPUMIsGuestDebugStateActivePending(PVMCPU pVCpu)
-{
-    return RT_BOOL(pVCpu->cpum.s.fUseFlags & CPUM_SYNC_DEBUG_REGS_GUEST);
-}
-
-
-/**
- * Checks if the hyper debug state is active.
- *
- * @returns boolean
- * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
- */
 VMMDECL(bool) CPUMIsHyperDebugStateActive(PVMCPU pVCpu)
 {
     return RT_BOOL(pVCpu->cpum.s.fUseFlags & CPUM_USED_DEBUG_REGS_HYPER);
-}
-
-
-/**
- * Checks if the hyper debug state is to be made active during the world-switch
- * (currently only used for the 32->64 switcher case).
- *
- * @returns boolean
- * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
- */
-VMMDECL(bool) CPUMIsHyperDebugStateActivePending(PVMCPU pVCpu)
-{
-    return RT_BOOL(pVCpu->cpum.s.fUseFlags & CPUM_SYNC_DEBUG_REGS_HYPER);
 }
 
Index: /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 87344)
+++ /trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 87345)
@@ -439,5 +439,4 @@
     Assert(!RTThreadPreemptIsEnabled(NIL_RTTHREAD));
     Assert(!(pVCpu->cpum.s.fUseFlags & CPUM_USED_FPU_GUEST));
-    Assert(!(pVCpu->cpum.s.fUseFlags & CPUM_SYNC_FPU_STATE));
 
     if (!pVM->cpum.s.HostFeatures.fLeakyFxSR)
@@ -509,5 +508,5 @@
         fSavedGuest = false;
     Assert(!(  pVCpu->cpum.s.fUseFlags
-             & (CPUM_USED_FPU_GUEST | CPUM_USED_FPU_HOST | CPUM_SYNC_FPU_STATE | CPUM_USED_MANUAL_XMM_RESTORE)));
+             & (CPUM_USED_FPU_GUEST | CPUM_USED_FPU_HOST | CPUM_USED_MANUAL_XMM_RESTORE)));
     return fSavedGuest;
 }
@@ -580,6 +579,5 @@
             pVCpu->cpum.s.Guest.dr[6] = ASMGetDR6();
     }
-    ASMAtomicAndU32(&pVCpu->cpum.s.fUseFlags, ~(  CPUM_USED_DEBUG_REGS_GUEST | CPUM_USED_DEBUG_REGS_HYPER
-                                                | CPUM_SYNC_DEBUG_REGS_GUEST | CPUM_SYNC_DEBUG_REGS_HYPER));
+    ASMAtomicAndU32(&pVCpu->cpum.s.fUseFlags, ~(CPUM_USED_DEBUG_REGS_GUEST | CPUM_USED_DEBUG_REGS_HYPER));
 
     /*
Index: /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 87344)
+++ /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 87345)
@@ -8214,6 +8214,6 @@
 #endif
     CPUMR0DebugStateMaybeSaveGuestAndRestoreHost(pVCpu, true /* save DR6 */);
-    Assert(!CPUMIsGuestDebugStateActive(pVCpu) && !CPUMIsGuestDebugStateActivePending(pVCpu));
-    Assert(!CPUMIsHyperDebugStateActive(pVCpu) && !CPUMIsHyperDebugStateActivePending(pVCpu));
+    Assert(!CPUMIsGuestDebugStateActive(pVCpu));
+    Assert(!CPUMIsHyperDebugStateActive(pVCpu));
 
     /* Restore host-state bits that VT-x only restores partially. */
Index: /trunk/src/VBox/VMM/include/CPUMInternal.h
===================================================================
--- /trunk/src/VBox/VMM/include/CPUMInternal.h	(revision 87344)
+++ /trunk/src/VBox/VMM/include/CPUMInternal.h	(revision 87345)
@@ -104,11 +104,4 @@
 #define CPUM_USED_DEBUG_REGS_GUEST      RT_BIT(9)
 
-/** Sync the FPU state on next entry (32->64 switcher only). */
-#define CPUM_SYNC_FPU_STATE             RT_BIT(16)
-/** Sync the debug state on next entry (32->64 switcher only). */
-#define CPUM_SYNC_DEBUG_REGS_GUEST      RT_BIT(17)
-/** Sync the debug state on next entry (32->64 switcher only).
- * Almost the same as CPUM_USE_DEBUG_REGS_HYPER in the raw-mode switchers. */
-#define CPUM_SYNC_DEBUG_REGS_HYPER      RT_BIT(18)
 /** Host CPU requires fxsave/fxrstor leaky bit handling. */
 #define CPUM_USE_FFXSR_LEAKY            RT_BIT(19)
Index: /trunk/src/VBox/VMM/include/CPUMInternal.mac
===================================================================
--- /trunk/src/VBox/VMM/include/CPUMInternal.mac	(revision 87344)
+++ /trunk/src/VBox/VMM/include/CPUMInternal.mac	(revision 87345)
@@ -63,7 +63,4 @@
 %define CPUM_USED_DEBUG_REGS_HYPER      RT_BIT(8)
 %define CPUM_USED_DEBUG_REGS_GUEST      RT_BIT(9)
-%define CPUM_SYNC_FPU_STATE             RT_BIT(16)
-%define CPUM_SYNC_DEBUG_REGS_GUEST      RT_BIT(17)
-%define CPUM_SYNC_DEBUG_REGS_HYPER      RT_BIT(18)
 %define CPUM_USE_FFXSR_LEAKY            RT_BIT(19)
 %define CPUM_USE_SUPPORTS_LONGMODE      RT_BIT(20)