Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp	(revision 87363)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp	(revision 87364)
@@ -29,15 +29,4 @@
 #include "UIToolBox.h"
 #include "UIWizardNewVM.h"
-
-class UITest : public QWidget
-{
-    Q_OBJECT;
-public:
-    UITest(QWidget *pParent = 0)
-        :QWidget(pParent)
-    {}
-    ~UITest(){}
-};
-
 
 /*********************************************************************************************************************************
@@ -244,8 +233,7 @@
 {
     prepare();
-    //setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Minimum);
-}
-
-bool UIToolBox::insertItem(int iIndex, QWidget *pWidget, const QString &strTitle, bool fAddEnableCheckBox /* = false */)
+}
+
+bool UIToolBox::insertPage(int iIndex, QWidget *pWidget, const QString &strTitle, bool fAddEnableCheckBox /* = false */)
 {
     if (m_pages.contains(iIndex))
@@ -284,5 +272,5 @@
 }
 
-void UIToolBox::setItemEnabled(int iIndex, bool fEnabled)
+void UIToolBox::setPageEnabled(int iIndex, bool fEnabled)
 {
     Q_UNUSED(fEnabled);
@@ -290,5 +278,5 @@
 }
 
-void UIToolBox::setItemText(int iIndex, const QString &strTitle)
+void UIToolBox::setPageTitle(int iIndex, const QString &strTitle)
 {
     QMap<int, UIToolBoxPage*>::iterator iterator = m_pages.find(iIndex);
@@ -298,5 +286,5 @@
 }
 
-void UIToolBox::setItemIcon(int iIndex, const QIcon &icon)
+void UIToolBox::setPageTitleIcon(int iIndex, const QIcon &icon)
 {
     QMap<int, UIToolBoxPage*>::iterator iterator = m_pages.find(iIndex);
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.h	(revision 87363)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.h	(revision 87364)
@@ -45,8 +45,8 @@
 
     UIToolBox(QWidget *pParent = 0);
-    bool insertItem(int iIndex, QWidget *pWidget, const QString &strTitle, bool fAddEnableCheckBox = false);
-    void setItemEnabled(int iIndex, bool fEnabled);
-    void setItemText(int iIndex, const QString &strTitle);
-    void setItemIcon(int iIndex, const QIcon &icon);
+    bool insertPage(int iIndex, QWidget *pWidget, const QString &strTitle, bool fAddEnableCheckBox = false);
+    void setPageEnabled(int iIndex, bool fEnabled);
+    void setPageTitle(int iIndex, const QString &strTitle);
+    void setPageTitleIcon(int iIndex, const QIcon &icon);
     void setCurrentPage(int iIndex);
 
@@ -54,6 +54,4 @@
 
     virtual void retranslateUi() /* override */;
-    //virtual QSize sizeHint() const /* override */;
-    //virtual QSize minimumSizeHint() const /* override */;
 
 private slots:
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 87363)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageExpert.cpp	(revision 87364)
@@ -55,21 +55,16 @@
     {
         m_pToolBox = new UIToolBox;
-        m_pToolBox->insertItem(ExpertToolboxItems_NameAndOSType, createNameOSTypeWidgets(/* fCreateUnattendedWidgets */ false,
+        m_pToolBox->insertPage(ExpertToolboxItems_NameAndOSType, createNameOSTypeWidgets(/* fCreateUnattendedWidgets */ false,
                                                                                          /* fCreateLabels */ false), "");
-        m_pToolBox->insertItem(ExpertToolboxItems_Unattended, createUnattendedWidgets(), "", false);
-        m_pToolBox->insertItem(ExpertToolboxItems_Disk, createDiskWidgets(), "");
-        m_pToolBox->insertItem(ExpertToolboxItems_Hardware, createHardwareWidgets(), "");
-        // m_pToolBox->insertItem(ExpertToolboxItems_UsernameHostname, createUserNameHostNameWidgets(/* fIncreaseLeftIndent */ true), "");
-        // m_pToolBox->insertItem(ExpertToolboxItems_GAInstall, createGAInstallWidgets(/* fIncreaseLeftIndent */ true), "");
-        // m_pToolBox->insertItem(ExpertToolboxItems_ProductKey, createProductKeyWidgets(/* fIncreaseLeftIndent */ true), "");
+        m_pToolBox->insertPage(ExpertToolboxItems_Unattended, createUnattendedWidgets(), "", false);
+        m_pToolBox->insertPage(ExpertToolboxItems_Disk, createDiskWidgets(), "");
+        m_pToolBox->insertPage(ExpertToolboxItems_Hardware, createHardwareWidgets(), "");
 
         m_pToolBox->setCurrentPage(ExpertToolboxItems_NameAndOSType);
         pMainLayout->addWidget(m_pToolBox);
 
-
         pMainLayout->addStretch();
         updateVirtualDiskSource();
     }
-
 
     createConnections();
@@ -204,8 +199,8 @@
     if (m_pToolBox)
     {
-        m_pToolBox->setItemText(ExpertToolboxItems_NameAndOSType, QString(UIWizardNewVM::tr("Name and operating system")));
-        m_pToolBox->setItemText(ExpertToolboxItems_Unattended, UIWizardNewVM::tr("Unattended Install"));
-        m_pToolBox->setItemText(ExpertToolboxItems_Disk, UIWizardNewVM::tr("Hard disk"));
-        m_pToolBox->setItemText(ExpertToolboxItems_Hardware, UIWizardNewVM::tr("Hardware"));
+        m_pToolBox->setPageTitle(ExpertToolboxItems_NameAndOSType, QString(UIWizardNewVM::tr("Name and operating system")));
+        m_pToolBox->setPageTitle(ExpertToolboxItems_Unattended, UIWizardNewVM::tr("Unattended Install"));
+        m_pToolBox->setPageTitle(ExpertToolboxItems_Disk, UIWizardNewVM::tr("Hard disk"));
+        m_pToolBox->setPageTitle(ExpertToolboxItems_Hardware, UIWizardNewVM::tr("Hardware"));
     }
 }
@@ -423,12 +418,12 @@
     markWidgets();
     bool fIsComplete = true;
-    m_pToolBox->setItemIcon(ExpertToolboxItems_NameAndOSType, QIcon());
-    m_pToolBox->setItemIcon(ExpertToolboxItems_Unattended, QIcon());
-    m_pToolBox->setItemIcon(ExpertToolboxItems_Disk, QIcon());
-    m_pToolBox->setItemIcon(ExpertToolboxItems_Hardware, QIcon());
+    m_pToolBox->setPageTitleIcon(ExpertToolboxItems_NameAndOSType, QIcon());
+    m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Unattended, QIcon());
+    m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Disk, QIcon());
+    m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Hardware, QIcon());
 
     if (!UIWizardPage::isComplete())
     {
-        m_pToolBox->setItemIcon(ExpertToolboxItems_NameAndOSType,
+        m_pToolBox->setPageTitleIcon(ExpertToolboxItems_NameAndOSType,
                                 UIIconPool::iconSet(":/status_error_16px.png"));
         fIsComplete = false;
@@ -437,5 +432,5 @@
     if (!m_pDiskSkip->isChecked() && !m_pDiskPresent->isChecked() && uiCommon().medium(m_pDiskSelector->id()).isNull())
     {
-        m_pToolBox->setItemIcon(ExpertToolboxItems_Disk,
+        m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Disk,
                                 UIIconPool::iconSet(":/status_error_16px.png"));
         fIsComplete = false;
@@ -447,5 +442,5 @@
         if (!isISOFileSelectorComplete())
         {
-            m_pToolBox->setItemIcon(ExpertToolboxItems_Unattended,
+            m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Unattended,
                                     UIIconPool::iconSet(":/status_error_16px.png"));
             fIsComplete = false;
@@ -454,5 +449,5 @@
         if (!checkGAISOFile())
         {
-            m_pToolBox->setItemIcon(ExpertToolboxItems_Unattended,
+            m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Unattended,
                                     UIIconPool::iconSet(":/status_error_16px.png"));
             fIsComplete = false;
@@ -462,5 +457,5 @@
             if (!m_pUserNamePasswordEditor->isComplete())
             {
-                m_pToolBox->setItemIcon(ExpertToolboxItems_Unattended,
+                m_pToolBox->setPageTitleIcon(ExpertToolboxItems_Unattended,
                                         UIIconPool::iconSet(":/status_error_16px.png"));
                 fIsComplete = false;